package grondag.fonthack.mixin;

import java.util.Map;
import net.minecraft.class_2583;
import net.minecraft.class_2960;
import net.minecraft.class_327;
import net.minecraft.class_377;
import net.minecraft.class_378;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import grondag.fonthack.ext.FontManagerExt;

@Mixin(class_378.class)
public class MixinFontManager implements FontManagerExt {
	@Shadow private class_377 missingStorage;
	@Shadow private Map<class_2960, class_377> fontStorages;
	@Shadow private Map<class_2960, class_2960> idOverrides;

	@Override
	public class_327 ext_createTextRenderer(class_2960 fontId) {
		return new class_327((identifier) -> {
			if(identifier.equals(class_2583.field_24359)) {
				identifier = fontId;
			}

			return fontStorages.getOrDefault(idOverrides.getOrDefault(identifier, identifier), missingStorage);
		});
	}

	@Override
	public class_377 ext_getFontStorage(class_2960 fontId) {
		return fontStorages.getOrDefault(idOverrides.getOrDefault(fontId, fontId), missingStorage);
	}
}
